
program Ondoyant;
{$APPTYPE GUI}

(* Programme original :
   http://alcatiz.developpez.com/tutoriel/owl/?page=pg_gdi *)

uses
  WinCrt, WinGraph, WinMouse;

(* http://pascal.developpez.com/telecharger/detail/id/1809/WinGraph *)

{$R WINGRAPH.RES}

const
  indiceMax    = 100;
  vitesse      =  50;
  dx1: integer =   4;
  dy1: integer =  10;
  dx2: integer =   3;
  dy2: integer =   9;

type
  tLigne = record
    x1, y1, x2, y2: integer;
    couleur: longword;
  end;
  tTabLignes = array[0..indiceMax]of tLigne;

var
  tabLignes: tTabLignes;
  indiceGeneral: integer;
  effacer: boolean;

function Initialise: boolean;
var
  pilote, mode: smallint;
  i: integer;
begin
  pilote := noPalette;
  mode := mFullScr;
  InitGraph(pilote, mode, '');
  result := (GraphResult = grOk);
  if result then
  begin
    for i := 0 to indiceMax do
      tabLignes[i].x1 := -1;
    indiceGeneral := 0;
    effacer := false;
  end;
end;

procedure NouvelleLigne(var coord, intervalle : integer; coordMax : integer; var couleur : longword);
var
  total : integer;
  signe : integer;
begin
  total := coord + intervalle;
  if (total < 0) or (total > coordMax) then
  begin
    if intervalle >= 0 then
      signe := -1
    else
      signe := 1;
    intervalle := signe * (3 + Random(12));
    couleur := Random($FFFFFE) + 1;
  end else
    coord := total;
end;

procedure DessinLigne(i: integer);
begin
  with tabLignes[i] do
  begin
    SetColor(couleur);
    Line(x1, y1, x2, y2);
  end;
end;

procedure Redessine;
var
  i: integer;
  ancienIndice: integer;
begin
  for i := 1 to 10 do
  begin
    ancienIndice := indiceGeneral;
    if indiceGeneral = indiceMax - 1 then
    begin
      indiceGeneral := 0;
      effacer := True;
    end else
      Inc(indiceGeneral);
    if effacer then
    begin
      //tabLignes[indiceGeneral].couleur := 0;
      DessinLigne(indiceGeneral);
    end;
    tabLignes[indiceGeneral] := tabLignes[ancienIndice];
    with tabLignes[indiceGeneral] do
    begin
      NouvelleLigne(x1, dx1, GetMaxX, couleur);
      NouvelleLigne(y1, dy1, GetMaxY, couleur);
      NouvelleLigne(x2, dx2, GetMaxX, couleur);
      NouvelleLigne(y2, dy2, GetMaxY, couleur);
    end;
    DessinLigne(indiceGeneral);
  end;
end;

var
  x, y: word;

begin
  Randomize;
  if Initialise then
  begin
    SetWriteMode(xorMode or transparent);
    x := GetMouseX;
    y := GetMouseY;
    repeat
      Redessine;
      Delay(vitesse);
    until KeyPressed or (Abs(GetMouseX - x) > 20) or (Abs(GetMouseY - Y) > 20) or (GetMouseButtons <> 0);
    CloseGraph;
  end;
end.
